c      program dVdz2_test
      subroutine dVdz2_test
c     ==== calls  dVdz2 ====
 
      parameter(nq0=5,nz=100)
      real*4   x(nz,nq0),q_0(nq0),x1(nz),zlog(nz),zlin(nz)
      real*4   cc_0(nq0)
      real*4   xlowz(nz)
      character*80   label(nq0)
      integer*4  isls(nq0)
c      data  q_0 /0.5, -0.7, 0.025, 0.1, 0.0 / !,  -0.85/
c      data  cc_0 /0.0, 0.8, 0.0, 0.0, 0.0/ !, 0.9/

c      data  q_0 /0.5, -0.55, 0.15, -0.7, 0.025 / !,  -0.85/
c      data  cc_0 /0.0, 0.7, 0.0, 0.8, 0.0/ !, 0.9/

      data  q_0 /0.5, 0.4, 0.0, -0.5, 0.5 / !,  -0.85/
      data  cc_0 /0.0, 0.1, 0.5, 1.0, 0.0/ !, 0.9/
c     __    om_0  1.0, 1.0, 1.0, 1.0, 1.0

      data  isls/1,2,3,5,4/
c      print*,'q_0, H_0 (in kms^-1 Mpc^-1), cc_0, z ?'
c      read(5,*)q_0,H_0,cc_0,z
c      x=dVdz(q_0,H_0,cc_0,z)
c      print*,'dVdz=',x

      H_0=50.0

c      label(1)='q\\d0\\u=0\\(0729)5, \\gl\\d0\\u=0\\(0729)0'
c      label(2)='q\\d0\\u=0\\(0729)2'
c      label(2)='q\\d0\\u=0\\(0729)1, \\gl\\d0\\u=0\\(0729)0'
c      label(4)='q\\d0\\u=1\\(0729)0'

c      label(3)='q\\d0\\u=-0\\(0729)7, \\gl\\d0\\u=0\\(0729)8'
c      label(4)='q\\d0\\u=0\\(0729)05, \\gl\\d0\\u=0\\(0729)0'
c      label(5)='q\\d0\\u=-0\\(0729)85, \\gl\\d0\\u=0\\(0729)9'

      label(1)='\\gW\\d0\\u=1, \\gl\\d0\\u=0'
      label(2)='\\gW\\d0\\u=0\\(0729)2, \\gl\\d0\\u=0\\(0729)8'
      label(3)='\\gW\\d0\\u=0\\(0729)05, \\gl\\d0\\u=0\\(0729)0'
      label(4)='\\gW\\d0\\u=0\\(0729)2, \\gl\\d0\\u=0'
      label(5)='\\gW\\d0\\u=0, \\gl\\d0\\u=0'

      label(2)='\\gW\\d0\\u=0\\(0729)3, \\gl\\d0\\u=0\\(0729)7'
      label(3)='\\gW\\d0\\u=0\\(0729)3, \\gl\\d0\\u=0'
      label(4)='\\gW\\d0\\u=0\\(0729)2, \\gl\\d0\\u=0\\(0729)8'
      label(5)='\\gW\\d0\\u=0\\(0729)05, \\gl\\d0\\u=0'



      cH3=(3.0e5/H_0)*(3.0e5/H_0)*(3.0e5/H_0)
      pi=3.1415926539
      V0=cH3 * pi*pi/180.0/180.0

      xmax=0.0
      write(6,'(a,$)')'Enter  zmax: '
      read(5,*)zmax

      do i=1,nq0
         do j=1,nz
c           ---- log ----
c            zlog(j)=(-1.0 + (real(j)-0.5)/15.0 )
c            z=exp( log(10.0)*zlog(j)) 
c           ---- linear ----
           
            zlin(j)= (real(j)-0.5) *zmax/nz
            z=zlin(j)

            z3=(1.0+z)*(1.0+z)*(1.0+z)
            x(j,i)=dVdz2(q_0(i),50.0,cc_0(i),z) *z3
c           ---- dV/d(ln z)= dV/ (1/z *dz) = z* dV/dz
c            x(j,i)=x(j,i) *z

            xlowz(j)=V0 *z*z 
c                        *z3
            
            if(x(j,i).gt.xmax)then
               xmax=x(j,i) 
c               print*,'xmax: q_0(i),cc_0(i),z,x(j,i)=',
c     _              q_0(i),cc_0(i),z,x(j,i)
            endif
c            if(xlowz(j).gt.xmax)xmax=xlowz(j)
         enddo
      enddo

c      write(6,'(a,g13.2,a,$)')'xmax=',xmax,'. Enter  xmax: '
      write(6,*)'xmax=',xmax,'. Enter  xmax: '
      read(5,*)xmax



      call pgbegin(0, '?', 1, 1)
      call pgscf(2)
      call pgslw(3)
 
      call pgvsize(1.0, 5.0, 1.0, 4.0)
c      call pgwindow(-1.0,1.0,0.0,xmax)
c      call pgbox('bcntsl',0.,0,'bcnts',0.,0)
c      call pglabel('z','(1+z)\\u3\\d  dV/d(ln z)',
c     _  'Comoving Vol. Element derivative (H\\d0\\u = 50 kms\\u-1\\d)')

      call pgwindow(0.0,zmax,0.0,xmax)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)
      call pglabel('z','(1+z)\\u3\\d  dV/dz', ' ')
c     _  'Comoving Vol. Element derivative (H\\d0\\u = 50 kms\\u-1\\d)')

      
      x0=0.9*xmax
      delx=0.08*xmax
      zz0=zmax/20.0 !+zmax/18.0
      zz1=4.0*zmax/20.0 !+zmax/18.0
      zz2=4.2*zmax/20.0 !+zmax/18.0
      do i=1,nq0
         do j=1,nz
            x1(j)=x(j,i)
         enddo

c         call pgline(nz,zlog,x1)
         call pgsls(isls(i))
         call pgline(nz,zlin,x1)
         call pgmove(zz0,x0-delx*real(i-1))
         call pgdraw(zz1,x0-delx*real(i-1))
         call pgsls(1)
         call pgtext(zz2,x0-delx*real(i-1)-0.01*xmax,label(i))
      enddo
      i=nq0+1
c      call pgsls(1)
c      call pgline(nz,zlin,xlowz)
c      call pgmove(zz0,x0-delx*real(i-1))
c      call pgdraw(zz1,x0-delx*real(i-1))
c      call pgsls(1)
c      call pgtext(zz2,x0-delx*real(i-1)-0.01*xmax,
c     _     'naive')
      


c      call pgiden
      call pgend

      end
 
      function dVdz2(q_0,H_0,cc_0,z)
c     ==== calculates derivative of volume element per sq. degree,
c     i.e. the rate at which (3-D) spatial volume increases through our 
c     past "time cone" as a function of  z. ====
c     ---- units of H_0 should be kms^-1 Mpc^-1,  
c          dVdz is in units of  Mpc^3 sq.deg.^-1, in proper coords ----
      

      real*4    dVdz,q_0,H_0,cc_0,z
 
      c=299792.4562
      pi=3.14159265359
      dl=propd2(q_0,H_0,cc_0,z) *(1.0+z)
      z6=(1.0+z)*(1.0+z)*(1.0+z)* (1.0+z)*(1.0+z)*(1.0+z)
      dVdz2= 4.0*pi*c *dl*dl /H_0 /z6 
     _     /sqrt(  1.0 + 2.0*(q_0+cc_0)*z 
     _     + cc_0* ( 1.0/(1.0+z)/(1.0+z) -1.0 )  )
      dVdz2= dVdz2 /(4.0*pi)  * (pi/180.0) *(pi/180.0)

      return
      end
      
