c      program d_ltest
      subroutine d_ltest
c     ==== calls  propdist ====

      print*,'q_0, H_0 (in kms^-1 Mpc^-1), z ?'
      read(5,*)q_0,H_0,z
      x=propdist(q_0,H_0,z)
      print*,'naive distance in Mpc = ',z*299792.4562/H_0
      print*,'proper distance in Mpc = ',x
      print*,'luminosity distance in Mpc = ',x*(1.0+z)
      end

      function propdist(q_0,H_0,z)
c     ==== calculates proper distance in Mpc ====
      real*4    propdist,q_0,H_0,z

      c=299792.4562
      if(q_0.eq.0)then
         propdist= z* (1.0+ z/2.0) /(1.0+z) /H_0 *c
      else
         x=sqrt(1.0+ 2.0*q_0*z)-1.0
         x=x* (q_0-1.0) +q_0 * z
         propdist=x/q_0/q_0 /(1.0+z) /H_0 *c
      endif
      return
      end
      
